<?php
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\OAuth;
use League\OAuth2\Client\Provider\Google;
require '../../vendor/autoload.php'; // Path to your autoload
	$settings			= 
	[
		'ClientID' 		=> 	'1082478245995-0bl4v0ok5986qqbrd71r8nfhd4hr1qpk.apps.googleusercontent.com',
		'ClientSecret' 		=> 	'tjRe7wHFkQQ9-s3aQDyDtjCG',
		'RefreshToken' 		=> 	'1//0eTmRYvU_eiOgCgYIARAAGA4SNwF-L9Iru70Kc9HwgItwHUje3svq8XkGLZr6ryRdtnSWS4ZCgq8IS6CDG5ZC683iUWnDXu4KTxk',
		'UserName'		=>	'ausfeed.online@gmail.com',
		'FromName'		=>	'Ausfeed Online',
	];

// EXAMPLE BEGIN
/*
	$message_options 		= 
	[
		'ReplyEmail'            => 'shane@gelven.com', // LIVE use pvogt@ausfeed.com
                'ReplyName'             => 'Shane Gelven', // LIVE use Ausfeed Australia Pty Ltd
                'UseReply'              => true,
		'to_list'		=> ['info@customclouddata.com'=>'CCD'], // Email & Name  
		//'cc_list'		=> ['shane@gelven.com'=>'Shane Gelven','gelvo71@hotmail.com'=>'HotGelvo'], // Emails & Name
		'bcc_list'              => ['gelvo71@hotmail.com'=>'HotGelvo','shane@gelven.com'=>'Shane Gelven'], // Emails & Name
		'filelist'		=> ['VendorDeclaration.pdf' => '/var/www/html/ausfeed.customclouddata.com/public/VendorDeclaration.pdf'],		
		'subject'		=> 'Subject 13',
		'content'		=> 'Content 13',
	];
*/
//print_r( $message_options );
//print_r( apiSendEmail($message_options) );
// EXAMPLE END

function apiSendEmail($message_options) {
		// Settings
		global $settings;
		$clientId               	= $settings['ClientID'];
               	$clientSecret           	= $settings['ClientSecret'];
               	$refreshToken           	= $settings['RefreshToken'];
               	$userName               	= $settings['UserName'];
           	$fromName               	= $settings['FromName'];
		$result				= array();		
		$provider               	= new Google(['clientId' => $clientId,'clientSecret' => $clientSecret,]);
		
		// Marshall Options
		$subject			= isset($message_options['subject']) 	? $message_options['subject'] 	 : '';
		$content                	= isset($message_options['content']) 	? $message_options['content'] 	 : '';
		$to_list			= isset($message_options['to_list']) 	? $message_options['to_list'] 	 : array();
		$cc_list			= isset($message_options['cc_list']) 	? $message_options['cc_list'] 	 : array();
		$bcc_list               	= isset($message_options['bcc_list'])   ? $message_options['bcc_list']   : array();
		$filelist			= isset($message_options['filelist']) 	? $message_options['filelist'] 	 : array();
		$use_reply			= isset($message_options['UseReply'])	? $message_options['UseReply']	 : false;
		$replyEmail             	= isset($message_options['ReplyEmail']) ? $message_options['ReplyEmail'] : $userName;
                $replyName              	= isset($message_options['ReplyName'])  ? $message_options['ReplyName']  : $fromName;

    		try {
			// PHPMailer Setup
        		$mail               	= new PHPMailer();
        		$mail->SMTPDebug    	= SMTP::DEBUG_OFF;
			$mail->SMTPSecure       = PHPMailer::ENCRYPTION_STARTTLS;
			$mail->CharSet          = PHPMailer::CHARSET_UTF8;
        		$mail->Host         	= 'smtp.gmail.com';
        		$mail->Port         	= 587;
        		$mail->SMTPAuth     	= true;
        		$mail->AuthType     	= 'XOAUTH2';
			$mail->isSMTP();
                        $mail->isHTML(true);
        		$mail->setOAuth(new OAuth(['provider' => $provider,'clientId' => $clientId,'clientSecret' => $clientSecret,'refreshToken' => $refreshToken,'userName' => $userName,]));
        		$mail->setFrom($userName, $fromName);

			// Reply To Setting
			if ( $use_reply === true ) {
        			$mail->addReplyTo($replyEmail, $replyName);
			}

			// Message Options
        		$mail->Subject      	= $subject;
        		$mail->Body         	= $content;
			foreach ($to_list as $to_email => $to_name) {
      				$mail->AddAddress($to_email, $to_name);
    			}
			foreach ($cc_list as $cc_email => $cc_name) {
				$mail->AddCC($cc_email, $cc_name);
                        }
			foreach ($bcc_list as $bcc_email => $bcc_name) {
                                $mail->AddBCC($bcc_email, $bcc_name);
                        }
    			foreach ($filelist as $file_name => $file_path) {
        			$mail->AddAttachment($file_path,$file_name);    
    			}

        		$result[0]                   = $mail->Send();
        		$result[1]                   = "Message sent successfully";
    		} catch(phpmailerException $e) {
        		$result[0]                   = false;
        		$result[1]                   = 'phpmailerException';
    		} catch(Exception $e){
        		$result[0]                   = false;
        		$result[1]                   = 'Exception';
    		}
    		return $result;
}
?>
